/*
 * RAMReader.c
 *
 * Created: 05.01.2016 22:09:18
 *  Author: Steven
 */ 

#include "RAMReader.h"


void setRAMBank(uint8_t bank) {
	switch(gameCartHead.usesController) {
		case MBC5:
			writeDataByte(0x4000, bank);
			break;
	}
}

/*
uint8_t getROMBankCounter() {
	uint8_t romSize=0;
	
	switch(gameCartHead.romSize) {
		case romSize32K:
		romSize= 0;
		break;
		case romSize64K:
		romSize= 3;
		break;
		case romSize128K:
		romSize= 7;
		break;
		case romSize256K:
		romSize= 15;
		break;
		case romSize512K:
		romSize= 31;
		break;
		case romSize1M:
		romSize= 63;
		break;
		case romSize2M:
		romSize= 127;
		break;
		case romSize4M:
		romSize= 255;
		break;
		case romSize1_1M:
		romSize= 71;
		break;
		case romSize1_2M:
		romSize= 79;
		break;
		case romSize1_5M:
		romSize= 95;
		break;
	}
	return romSize;
}*/

void setRAMEnabled(bool state) {
	uint8_t actual=0;
	
	switch(state) {
		case true:
		actual=0x0A;
		break;
		case false:
		actual=0x00;
		break;
	}
	//MBC2 3 (Enables also Timer) 5
	switch(gameCartHead.usesController) {
		case MBC1:
			if(state==true) {
				writeDataByte(0x6100, 0x01);//Enable RAM Bank Mode
			}
			else {
				writeDataByte(0x6100, 0x00);//Disable RAM Bank Mode and switch to ROM Bank mode
			}
			writeDataByte(0x0000, actual);
			break;
		case MBC2:
			writeDataByte(0x0000, actual);
			break;
		case MBC3:
			writeDataByte(0x0000, actual);
		case MBC4:
			writeDataByte(0x0000, actual);
			break;
		case MBC5:
			writeDataByte(0x0000, actual);
			break;
	}

}

void readRAMBank(uint8_t bankNr, void (*function) (uint8_t)) {
	writeDataByte(0x1FFF, 0x0A);
	writeDataByte(0x6000,0x01);
	writeDataByte(0x4000, bankNr);
	//setRAMBank(bankNr);
	readDataFromTo(0xA000, 0xBFFF, function);
}

void readRAMBanks(uint8_t bankStart, uint8_t bankEnd, void (*function) (uint8_t)) {
	uint16_t i=0;
	for(i=bankStart;i<=bankEnd;i++) {
		readRAMBank(i, function);
	}
}

void readRAM(void (*function) (uint8_t)) {


	writeDataByte(0x4000, 1);

	uint16_t i=0;
	for(i=0x0000;i<=0x1FFF;i++) {
		writeDataByte(i, 0x0A);
	}
	
	_delay_ms(1000);
	//setRAMBank(bankNr);
	for(i=0xA000;i<=0xBFFF;i++) {
		function(readDataByte(i));
	}
}